﻿package com.nhe.gfx {
	import flash.display.BitmapData;
	import flash.filters.BlurFilter;
	import flash.filters.ColorMatrixFilter;
	import flash.geom.ColorTransform;
	import flash.geom.Matrix;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	
	public class MagicWand {
		
	
			
		
		public static function selectColors(bitmapData:BitmapData,x:Number,y:Number):BitmapData
		{
			
	
			var rgb:Number = bitmapData.getPixel(x,y);
			
			var rng:Array = [ -50, 50];
			
			var rmin:Number = Math.min(255,Math.max(0,((rgb >> 16) & 0xff) + rng[0] ));
			var gmin:Number = Math.min(255,Math.max(0,((rgb >> 8) & 0xff) + rng[0] ));
			var bmin:Number = Math.min(255,Math.max(0,(rgb  & 0xff) + rng[0] ));
			var rgbMin:Number = rmin<<16 | gmin<<8 | bmin;
			
			var rmax:Number = Math.min(255,Math.max(0,((rgb >> 16) & 0xff) + rng[1] ));
			var gmax:Number = Math.min(255,Math.max(0,((rgb >> 8) & 0xff ) + rng[1] ));
			var bmax:Number = Math.min(255,Math.max(0, (rgb & 0xff) + rng[1] ));
			var rgbMax:Number = rmax<<16 | gmax<<8 | bmax;
	
			
			rmin = (rgbMin >> 16) & 0xff;
			gmin = (rgbMin >> 8) & 0xff;
			bmin = rgbMin  & 0xff;
			
			rmax = (rgbMax >> 16) & 0xff;
			gmax = (rgbMax >> 8) & 0xff;
			bmax = rgbMax  & 0xff;
			
			var tmp:Number
			
			if (rmin>rmax){
				tmp=rmin;
				rmin = rmax;
				rmax = tmp;
			}
			
			if (gmin>gmax){
				tmp =gmin;
				gmin = gmax;
				gmax = tmp;
			}
			
			if (bmin>bmax){
				tmp=bmin;
				bmin = bmax;
				bmax = tmp;
			}
			
			var mask:BitmapData = new BitmapData( bitmapData.width, bitmapData.height, true, 0);
			
			var hideColor:Number = 0xffff00ff;
			var rect:Rectangle = bitmapData.rect;
			var zero:Point = new Point();
			
			mask.threshold( bitmapData, rect, zero, "<", rmin<<16,hideColor,0x00FF0000,true);
			mask.threshold( mask, rect, zero, "<", gmin<<8,hideColor,0x0000ff00,true);
			mask.threshold( mask, rect, zero, "<", bmin,hideColor,0x000000ff,true);
			
			mask.threshold( mask, rect, zero, ">", rmax<<16,hideColor,0x00FF0000,true);
			mask.threshold( mask, rect, zero, ">", gmax<<8,hideColor,0x0000ff00,true);
			mask.threshold( mask, rect, zero, ">", bmax,hideColor,0x000000ff,true);
		
			mask.threshold( mask, rect, zero, "!=", hideColor,0xffffffff,0xFFFFFF,true);
			
			
			mask.floodFill(x, y, 0);
			mask.threshold( mask, rect, zero, "!=", 0x00FFFFFF,hideColor,0xff000000,true);
			

			
			mask.applyFilter( mask,rect,zero, new BlurFilter(2,2,1));
	
			var transformMap:BitmapData = new BitmapData( bitmapData.width, bitmapData.height, true, 0);
			
			transformMap.copyPixels(bitmapData,rect,zero,mask,zero,true);
			
			mask.dispose();
	
			return transformMap;
			
		}
		
	}
}